/* screen-notification.c generated by valac 0.36.2, the Vala compiler
 * generated from screen-notification.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>


#define POMODORO_TYPE_SCREEN_NOTIFICATION (pomodoro_screen_notification_get_type ())
#define POMODORO_SCREEN_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification))
#define POMODORO_SCREEN_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotificationClass))
#define POMODORO_IS_SCREEN_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_SCREEN_NOTIFICATION))
#define POMODORO_IS_SCREEN_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_SCREEN_NOTIFICATION))
#define POMODORO_SCREEN_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotificationClass))

typedef struct _PomodoroScreenNotification PomodoroScreenNotification;
typedef struct _PomodoroScreenNotificationClass PomodoroScreenNotificationClass;
typedef struct _PomodoroScreenNotificationPrivate PomodoroScreenNotificationPrivate;

#define POMODORO_TYPE_TIMER (pomodoro_timer_get_type ())
#define POMODORO_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_TIMER, PomodoroTimer))
#define POMODORO_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_TIMER, PomodoroTimerClass))
#define POMODORO_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_TIMER))
#define POMODORO_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_TIMER))
#define POMODORO_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_TIMER, PomodoroTimerClass))

typedef struct _PomodoroTimer PomodoroTimer;
typedef struct _PomodoroTimerClass PomodoroTimerClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_region_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_region_destroy (var), NULL)))

#define POMODORO_TYPE_TIMER_STATE (pomodoro_timer_state_get_type ())
#define POMODORO_TIMER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_TIMER_STATE, PomodoroTimerState))
#define POMODORO_TIMER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_TIMER_STATE, PomodoroTimerStateClass))
#define POMODORO_IS_TIMER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_TIMER_STATE))
#define POMODORO_IS_TIMER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_TIMER_STATE))
#define POMODORO_TIMER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_TIMER_STATE, PomodoroTimerStateClass))

typedef struct _PomodoroTimerState PomodoroTimerState;
typedef struct _PomodoroTimerStateClass PomodoroTimerStateClass;

#define POMODORO_TYPE_BREAK_STATE (pomodoro_break_state_get_type ())
#define POMODORO_BREAK_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_BREAK_STATE, PomodoroBreakState))
#define POMODORO_BREAK_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_BREAK_STATE, PomodoroBreakStateClass))
#define POMODORO_IS_BREAK_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_BREAK_STATE))
#define POMODORO_IS_BREAK_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_BREAK_STATE))
#define POMODORO_BREAK_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_BREAK_STATE, PomodoroBreakStateClass))

typedef struct _PomodoroBreakState PomodoroBreakState;
typedef struct _PomodoroBreakStateClass PomodoroBreakStateClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PomodoroScreenNotification {
	GtkWindow parent_instance;
	PomodoroScreenNotificationPrivate * priv;
};

struct _PomodoroScreenNotificationClass {
	GtkWindowClass parent_class;
};

struct _PomodoroScreenNotificationPrivate {
	GObject* idle_monitor;
	gboolean _close_on_activity;
	GtkLabel* minutes_label;
	GtkLabel* seconds_label;
	guint fade_in_timeout_id;
	guint fade_out_timeout_id;
	PomodoroTimer* timer;
	gulong timer_elapsed_id;
	guint close_on_activity_id;
	guint32 last_event_time;
	gdouble last_motion_x;
	gdouble last_motion_y;
	gboolean _pass_through;
};


static gpointer pomodoro_screen_notification_parent_class = NULL;
static GtkBuildableIface * pomodoro_screen_notification_gtk_buildable_parent_iface = NULL;

GType pomodoro_screen_notification_get_type (void) G_GNUC_CONST;
GType pomodoro_timer_get_type (void) G_GNUC_CONST;
#define POMODORO_SCREEN_NOTIFICATION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotificationPrivate))
enum  {
	POMODORO_SCREEN_NOTIFICATION_DUMMY_PROPERTY
};
static void pomodoro_screen_notification_unschedule_close_on_activity (PomodoroScreenNotification* self);
#define POMODORO_SCREEN_NOTIFICATION_IDLE_TIME_TO_CLOSE ((guint) 600)
#define POMODORO_SCREEN_NOTIFICATION_MIN_DISPLAY_TIME ((guint) 500)
#define POMODORO_SCREEN_NOTIFICATION_FADE_IN_TIME ((guint) 180)
#define POMODORO_SCREEN_NOTIFICATION_FADE_OUT_TIME ((guint) 180)
#define POMODORO_SCREEN_NOTIFICATION_MOTION_DISTANCE_TO_CLOSE ((guint) 20)
static void pomodoro_screen_notification_do_set_pass_through (PomodoroScreenNotification* self, gboolean value);
static void pomodoro_screen_notification_real_realize (GtkWidget* base);
static gboolean pomodoro_screen_notification_get_pass_through (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_real_parser_finished (GtkBuildable* base, GtkBuilder* builder);
static void pomodoro_screen_notification_on_timer_state_changed (PomodoroScreenNotification* self);
GType pomodoro_timer_state_get_type (void) G_GNUC_CONST;
PomodoroTimerState* pomodoro_timer_get_state (PomodoroTimer* self);
GType pomodoro_break_state_get_type (void) G_GNUC_CONST;
static void pomodoro_screen_notification_on_timer_elapsed_notify (PomodoroScreenNotification* self);
static void _pomodoro_screen_notification_on_timer_elapsed_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
gdouble pomodoro_timer_get_remaining (PomodoroTimer* self);
static void pomodoro_screen_notification_real_show (GtkWidget* base);
static void pomodoro_screen_notification_fade_in (PomodoroScreenNotification* self);
void pomodoro_screen_notification_close (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_fade_out (PomodoroScreenNotification* self);
static gboolean pomodoro_screen_notification_on_fade_in_timeout (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_set_pass_through (PomodoroScreenNotification* self, gboolean value);
static gboolean pomodoro_screen_notification_on_fade_out_timeout (PomodoroScreenNotification* self);
static gboolean _pomodoro_screen_notification_on_fade_in_timeout_gsource_func (gpointer self);
static void pomodoro_screen_notification_schedule_close_on_activity (PomodoroScreenNotification* self);
static void pomodoro_screen_notification_set_close_on_activity (PomodoroScreenNotification* self, gboolean value);
static gboolean _pomodoro_screen_notification_on_fade_out_timeout_gsource_func (gpointer self);
static guint32 pomodoro_screen_notification_get_idle_time (PomodoroScreenNotification* self);
static gboolean pomodoro_screen_notification_real_event (GtkWidget* base, GdkEvent* event);
static gboolean pomodoro_screen_notification_get_close_on_activity (PomodoroScreenNotification* self);
static gboolean pomodoro_screen_notification_on_close_on_activity_timeout (PomodoroScreenNotification* self);
static gboolean _pomodoro_screen_notification_on_close_on_activity_timeout_gsource_func (gpointer self);
PomodoroScreenNotification* pomodoro_screen_notification_new (void);
PomodoroScreenNotification* pomodoro_screen_notification_construct (GType object_type);
static GObject * pomodoro_screen_notification_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
PomodoroTimer* pomodoro_timer_get_default (void);
static void _pomodoro_screen_notification_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender, PomodoroTimerState* state, PomodoroTimerState* previous_state, gpointer self);
static void pomodoro_screen_notification_finalize (GObject * obj);
static void _vala_pomodoro_screen_notification_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_pomodoro_screen_notification_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void pomodoro_screen_notification_do_set_pass_through (PomodoroScreenNotification* self, gboolean value) {
	gboolean _tmp0_;
	gint64 _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_pass_through = _tmp0_;
	_tmp1_ = g_get_real_time ();
	self->priv->last_event_time = (guint32) (_tmp1_ / 1000);
	self->priv->last_motion_x = -1.0;
	self->priv->last_motion_y = -1.0;
	_tmp2_ = value;
	if (_tmp2_) {
		cairo_region_t* _tmp3_;
		cairo_region_t* _tmp4_;
		_tmp3_ = cairo_region_create ();
		_tmp4_ = _tmp3_;
		gtk_widget_input_shape_combine_region ((GtkWidget*) self, _tmp4_);
		_cairo_region_destroy0 (_tmp4_);
	} else {
		gtk_widget_input_shape_combine_region ((GtkWidget*) self, NULL);
	}
	_tmp5_ = gtk_widget_get_realized ((GtkWidget*) self);
	if (_tmp5_) {
		GdkWindow* window;
		GdkWindow* _tmp6_;
		GdkWindow* _tmp7_;
		GdkCursor* _tmp8_ = NULL;
		gboolean _tmp9_;
		GdkCursor* cursor;
		GdkCursor* _tmp13_;
		GdkWindow* _tmp14_;
		GdkCursor* _tmp15_;
		_tmp6_ = gtk_widget_get_window ((GtkWidget*) self);
		_tmp7_ = _g_object_ref0 (_tmp6_);
		window = _tmp7_;
		_tmp9_ = value;
		if (_tmp9_) {
			_g_object_unref0 (_tmp8_);
			_tmp8_ = NULL;
		} else {
			GdkWindow* _tmp10_;
			GdkDisplay* _tmp11_;
			GdkCursor* _tmp12_;
			_tmp10_ = window;
			_tmp11_ = gdk_window_get_display (_tmp10_);
			_tmp12_ = gdk_cursor_new_from_name (_tmp11_, "none");
			_g_object_unref0 (_tmp8_);
			_tmp8_ = _tmp12_;
		}
		_tmp13_ = _g_object_ref0 (_tmp8_);
		cursor = _tmp13_;
		_tmp14_ = window;
		_tmp15_ = cursor;
		gdk_window_set_cursor (_tmp14_, _tmp15_);
		_g_object_unref0 (cursor);
		_g_object_unref0 (_tmp8_);
		_g_object_unref0 (window);
	}
}


static void pomodoro_screen_notification_real_realize (GtkWidget* base) {
	PomodoroScreenNotification * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = (PomodoroScreenNotification*) base;
	GTK_WIDGET_CLASS (pomodoro_screen_notification_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
	_tmp0_ = pomodoro_screen_notification_get_pass_through (self);
	_tmp1_ = _tmp0_;
	pomodoro_screen_notification_do_set_pass_through (self, _tmp1_);
}


static void pomodoro_screen_notification_real_parser_finished (GtkBuildable* base, GtkBuilder* builder) {
	PomodoroScreenNotification * self;
	GtkBuilder* _tmp0_;
	GtkStyleContext* style_context;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	self = (PomodoroScreenNotification*) base;
	g_return_if_fail (builder != NULL);
	_tmp0_ = builder;
	pomodoro_screen_notification_gtk_buildable_parent_iface->parser_finished ((GtkBuildable*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp0_);
	_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	style_context = _tmp2_;
	gtk_style_context_add_class (style_context, "hidden");
	_g_object_unref0 (style_context);
}


static void _pomodoro_screen_notification_on_timer_elapsed_notify_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	pomodoro_screen_notification_on_timer_elapsed_notify ((PomodoroScreenNotification*) self);
}


static void pomodoro_screen_notification_on_timer_state_changed (PomodoroScreenNotification* self) {
	gulong _tmp0_;
	PomodoroTimer* _tmp3_;
	PomodoroTimerState* _tmp4_;
	PomodoroTimerState* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timer_elapsed_id;
	if (_tmp0_ != ((gulong) 0)) {
		PomodoroTimer* _tmp1_;
		gulong _tmp2_;
		_tmp1_ = self->priv->timer;
		_tmp2_ = self->priv->timer_elapsed_id;
		g_signal_handler_disconnect ((GObject*) _tmp1_, _tmp2_);
		self->priv->timer_elapsed_id = (gulong) 0;
	}
	_tmp3_ = self->priv->timer;
	_tmp4_ = pomodoro_timer_get_state (_tmp3_);
	_tmp5_ = _tmp4_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, POMODORO_TYPE_BREAK_STATE)) {
		PomodoroTimer* _tmp6_;
		gulong _tmp7_;
		_tmp6_ = self->priv->timer;
		_tmp7_ = g_signal_connect_object ((GObject*) _tmp6_, "notify::elapsed", (GCallback) _pomodoro_screen_notification_on_timer_elapsed_notify_g_object_notify, self, G_CONNECT_AFTER);
		self->priv->timer_elapsed_id = _tmp7_;
		pomodoro_screen_notification_on_timer_elapsed_notify (self);
	}
}


static void pomodoro_screen_notification_on_timer_elapsed_notify (PomodoroScreenNotification* self) {
	guint remaining;
	PomodoroTimer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	guint minutes;
	guint seconds;
	GtkLabel* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkLabel* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->timer;
	_tmp1_ = pomodoro_timer_get_remaining (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = ceil (_tmp2_);
	_tmp4_ = MAX (_tmp3_, 0.0);
	remaining = (guint) _tmp4_;
	minutes = remaining / 60;
	seconds = remaining % 60;
	_tmp5_ = self->priv->minutes_label;
	_tmp6_ = g_strdup_printf ("%02u", minutes);
	_tmp7_ = _tmp6_;
	gtk_label_set_label (_tmp5_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->seconds_label;
	_tmp9_ = g_strdup_printf ("%02u", seconds);
	_tmp10_ = _tmp9_;
	gtk_label_set_label (_tmp8_, _tmp10_);
	_g_free0 (_tmp10_);
}


static void pomodoro_screen_notification_real_show (GtkWidget* base) {
	PomodoroScreenNotification * self;
	self = (PomodoroScreenNotification*) base;
	pomodoro_screen_notification_fade_in (self);
}


void pomodoro_screen_notification_close (PomodoroScreenNotification* self) {
	g_return_if_fail (self != NULL);
	pomodoro_screen_notification_fade_out (self);
}


static gboolean pomodoro_screen_notification_on_fade_in_timeout (PomodoroScreenNotification* self) {
	gboolean result = FALSE;
	GObject* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->fade_in_timeout_id = (guint) 0;
	_tmp0_ = self->priv->idle_monitor;
	if (_tmp0_ == NULL) {
		pomodoro_screen_notification_set_pass_through (self, FALSE);
	}
	result = FALSE;
	return result;
}


static gboolean pomodoro_screen_notification_on_fade_out_timeout (PomodoroScreenNotification* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->fade_out_timeout_id = (guint) 0;
	gtk_window_close (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
	result = FALSE;
	return result;
}


static gboolean _pomodoro_screen_notification_on_fade_in_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = pomodoro_screen_notification_on_fade_in_timeout ((PomodoroScreenNotification*) self);
	return result;
}


static void pomodoro_screen_notification_fade_in (PomodoroScreenNotification* self) {
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkStyleContext* _tmp2_;
	guint _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_visible ((GtkWidget*) self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		GTK_WIDGET_CLASS (pomodoro_screen_notification_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
	}
	gtk_window_present (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_remove_class (_tmp2_, "hidden");
	pomodoro_screen_notification_set_pass_through (self, TRUE);
	_tmp3_ = self->priv->fade_in_timeout_id;
	if (_tmp3_ == ((guint) 0)) {
		guint _tmp4_;
		_tmp4_ = g_timeout_add_full (G_PRIORITY_DEFAULT, POMODORO_SCREEN_NOTIFICATION_FADE_IN_TIME, _pomodoro_screen_notification_on_fade_in_timeout_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->fade_in_timeout_id = _tmp4_;
	}
	pomodoro_screen_notification_schedule_close_on_activity (self);
}


static gboolean _pomodoro_screen_notification_on_fade_out_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = pomodoro_screen_notification_on_fade_out_timeout ((PomodoroScreenNotification*) self);
	return result;
}


static void pomodoro_screen_notification_fade_out (PomodoroScreenNotification* self) {
	GtkStyleContext* _tmp0_;
	guint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "hidden");
	pomodoro_screen_notification_set_pass_through (self, TRUE);
	pomodoro_screen_notification_set_close_on_activity (self, FALSE);
	pomodoro_screen_notification_unschedule_close_on_activity (self);
	_tmp1_ = self->priv->fade_out_timeout_id;
	if (_tmp1_ == ((guint) 0)) {
		guint _tmp2_;
		_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, POMODORO_SCREEN_NOTIFICATION_FADE_OUT_TIME, _pomodoro_screen_notification_on_fade_out_timeout_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->fade_out_timeout_id = _tmp2_;
	}
}


static guint32 pomodoro_screen_notification_get_idle_time (PomodoroScreenNotification* self) {
	guint32 result = 0U;
	guint32 _tmp0_ = 0U;
	guint32 _tmp1_;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp1_ = self->priv->last_event_time;
	if (_tmp1_ != ((guint32) 0)) {
		guint32 _tmp2_;
		guint32 _tmp3_;
		_tmp2_ = gtk_get_current_event_time ();
		_tmp3_ = self->priv->last_event_time;
		_tmp0_ = _tmp2_ - _tmp3_;
	} else {
		_tmp0_ = (guint32) 0;
	}
	result = _tmp0_;
	return result;
}


static gboolean pomodoro_screen_notification_real_event (GtkWidget* base, GdkEvent* event) {
	PomodoroScreenNotification * self;
	gboolean result = FALSE;
	gboolean _tmp0_;
	guint32 event_time;
	GdkEvent* _tmp3_;
	guint32 _tmp4_;
	guint32 idle_time;
	guint32 _tmp5_;
	GdkEvent* _tmp6_;
	GdkEventType _tmp7_;
	self = (PomodoroScreenNotification*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = self->priv->_close_on_activity;
	if (!_tmp0_) {
		GdkEvent* _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = event;
		_tmp2_ = GTK_WIDGET_CLASS (pomodoro_screen_notification_parent_class)->event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp1_);
		result = _tmp2_;
		return result;
	}
	_tmp3_ = event;
	_tmp4_ = gdk_event_get_time (_tmp3_);
	event_time = _tmp4_;
	_tmp5_ = pomodoro_screen_notification_get_idle_time (self);
	idle_time = _tmp5_;
	_tmp6_ = event;
	_tmp7_ = _tmp6_->type;
	switch (_tmp7_) {
		case GDK_MOTION_NOTIFY:
		{
			GdkEvent* _tmp8_;
			GdkEventMotion* _tmp9_;
			GdkEventMotion* _tmp10_;
			gint16 _tmp11_;
			gdouble _tmp12_ = 0.0;
			gdouble _tmp13_;
			gdouble dx;
			gdouble _tmp19_ = 0.0;
			gdouble _tmp20_;
			gdouble dy;
			gdouble distance;
			gdouble _tmp26_;
			gdouble _tmp27_;
			gdouble _tmp28_;
			gdouble _tmp29_;
			GdkEvent* _tmp30_;
			GdkEventMotion* _tmp31_;
			GdkEventMotion* _tmp32_;
			gdouble _tmp33_;
			GdkEvent* _tmp34_;
			GdkEventMotion* _tmp35_;
			GdkEventMotion* _tmp36_;
			gdouble _tmp37_;
			guint32 _tmp38_;
			gdouble _tmp39_;
			_tmp8_ = event;
			_tmp9_ = (GdkEventMotion *) (_tmp8_);
			_tmp10_ = _tmp9_;
			_tmp11_ = _tmp10_->is_hint;
			if (((gint) _tmp11_) == 1) {
				result = TRUE;
				return result;
			}
			_tmp13_ = self->priv->last_motion_x;
			if (_tmp13_ >= 0.0) {
				GdkEvent* _tmp14_;
				GdkEventMotion* _tmp15_;
				GdkEventMotion* _tmp16_;
				gdouble _tmp17_;
				gdouble _tmp18_;
				_tmp14_ = event;
				_tmp15_ = (GdkEventMotion *) (_tmp14_);
				_tmp16_ = _tmp15_;
				_tmp17_ = _tmp16_->x_root;
				_tmp18_ = self->priv->last_motion_x;
				_tmp12_ = _tmp17_ - _tmp18_;
			} else {
				_tmp12_ = 0.0;
			}
			dx = _tmp12_;
			_tmp20_ = self->priv->last_motion_y;
			if (_tmp20_ >= 0.0) {
				GdkEvent* _tmp21_;
				GdkEventMotion* _tmp22_;
				GdkEventMotion* _tmp23_;
				gdouble _tmp24_;
				gdouble _tmp25_;
				_tmp21_ = event;
				_tmp22_ = (GdkEventMotion *) (_tmp21_);
				_tmp23_ = _tmp22_;
				_tmp24_ = _tmp23_->y_root;
				_tmp25_ = self->priv->last_motion_y;
				_tmp19_ = _tmp24_ - _tmp25_;
			} else {
				_tmp19_ = 0.0;
			}
			dy = _tmp19_;
			_tmp26_ = dx;
			_tmp27_ = dx;
			_tmp28_ = dy;
			_tmp29_ = dy;
			distance = (_tmp26_ * _tmp27_) + (_tmp28_ * _tmp29_);
			_tmp30_ = event;
			_tmp31_ = (GdkEventMotion *) (_tmp30_);
			_tmp32_ = _tmp31_;
			_tmp33_ = _tmp32_->x_root;
			self->priv->last_motion_x = _tmp33_;
			_tmp34_ = event;
			_tmp35_ = (GdkEventMotion *) (_tmp34_);
			_tmp36_ = _tmp35_;
			_tmp37_ = _tmp36_->y_root;
			self->priv->last_motion_y = _tmp37_;
			_tmp38_ = event_time;
			self->priv->last_event_time = _tmp38_;
			_tmp39_ = distance;
			if (_tmp39_ > ((gdouble) (POMODORO_SCREEN_NOTIFICATION_MOTION_DISTANCE_TO_CLOSE * POMODORO_SCREEN_NOTIFICATION_MOTION_DISTANCE_TO_CLOSE))) {
				pomodoro_screen_notification_close (self);
			}
			break;
		}
		case GDK_BUTTON_PRESS:
		case GDK_KEY_PRESS:
		case GDK_TOUCH_BEGIN:
		{
			guint32 _tmp40_;
			guint32 _tmp41_;
			_tmp40_ = event_time;
			self->priv->last_event_time = _tmp40_;
			_tmp41_ = idle_time;
			if (_tmp41_ > ((guint32) POMODORO_SCREEN_NOTIFICATION_IDLE_TIME_TO_CLOSE)) {
				pomodoro_screen_notification_close (self);
			}
			break;
		}
		case GDK_FOCUS_CHANGE:
		{
			guint32 _tmp42_;
			_tmp42_ = event_time;
			self->priv->last_event_time = _tmp42_;
			pomodoro_screen_notification_close (self);
			break;
		}
		default:
		{
			break;
		}
	}
	result = TRUE;
	return result;
}


static gboolean pomodoro_screen_notification_on_close_on_activity_timeout (PomodoroScreenNotification* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->close_on_activity_id = (guint) 0;
	pomodoro_screen_notification_set_close_on_activity (self, TRUE);
	result = G_SOURCE_REMOVE;
	return result;
}


static void pomodoro_screen_notification_unschedule_close_on_activity (PomodoroScreenNotification* self) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->close_on_activity_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->close_on_activity_id;
		g_source_remove (_tmp1_);
		self->priv->close_on_activity_id = (guint) 0;
	}
}


static gboolean _pomodoro_screen_notification_on_close_on_activity_timeout_gsource_func (gpointer self) {
	gboolean result;
	result = pomodoro_screen_notification_on_close_on_activity_timeout ((PomodoroScreenNotification*) self);
	return result;
}


static void pomodoro_screen_notification_schedule_close_on_activity (PomodoroScreenNotification* self) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	pomodoro_screen_notification_unschedule_close_on_activity (self);
	_tmp0_ = g_timeout_add_full (G_PRIORITY_DEFAULT, POMODORO_SCREEN_NOTIFICATION_MIN_DISPLAY_TIME, _pomodoro_screen_notification_on_close_on_activity_timeout_gsource_func, g_object_ref (self), g_object_unref);
	self->priv->close_on_activity_id = _tmp0_;
}


PomodoroScreenNotification* pomodoro_screen_notification_construct (GType object_type) {
	PomodoroScreenNotification * self = NULL;
	self = (PomodoroScreenNotification*) g_object_new (object_type, NULL);
	return self;
}


PomodoroScreenNotification* pomodoro_screen_notification_new (void) {
	return pomodoro_screen_notification_construct (POMODORO_TYPE_SCREEN_NOTIFICATION);
}


static gboolean pomodoro_screen_notification_get_pass_through (PomodoroScreenNotification* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_pass_through;
	result = _tmp0_;
	return result;
}


static void pomodoro_screen_notification_set_pass_through (PomodoroScreenNotification* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	pomodoro_screen_notification_do_set_pass_through (self, _tmp0_);
}


static gboolean pomodoro_screen_notification_get_close_on_activity (PomodoroScreenNotification* self) {
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_close_on_activity;
	result = _tmp0_;
	return result;
}


static void pomodoro_screen_notification_set_close_on_activity (PomodoroScreenNotification* self, gboolean value) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_close_on_activity = _tmp0_;
}


static void _pomodoro_screen_notification_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender, PomodoroTimerState* state, PomodoroTimerState* previous_state, gpointer self) {
	pomodoro_screen_notification_on_timer_state_changed ((PomodoroScreenNotification*) self);
}


static GObject * pomodoro_screen_notification_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroScreenNotification * self;
	PomodoroTimer* _tmp0_;
	PomodoroTimer* _tmp1_;
	parent_class = G_OBJECT_CLASS (pomodoro_screen_notification_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
	_tmp0_ = pomodoro_timer_get_default ();
	self->priv->timer = _tmp0_;
	_tmp1_ = self->priv->timer;
	g_signal_connect_object (_tmp1_, "state-changed", (GCallback) _pomodoro_screen_notification_on_timer_state_changed_pomodoro_timer_state_changed, self, 0);
	pomodoro_screen_notification_on_timer_state_changed (self);
	gtk_window_fullscreen ((GtkWindow*) self);
	gtk_window_stick ((GtkWindow*) self);
	gtk_window_set_keep_above ((GtkWindow*) self, TRUE);
	return obj;
}


static void pomodoro_screen_notification_class_init (PomodoroScreenNotificationClass * klass) {
	gint PomodoroScreenNotification_private_offset;
	pomodoro_screen_notification_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PomodoroScreenNotificationPrivate));
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget *)) pomodoro_screen_notification_real_realize;
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget *)) pomodoro_screen_notification_real_show;
	((GtkWidgetClass *) klass)->event = (gboolean (*) (GtkWidget *, GdkEvent*)) pomodoro_screen_notification_real_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_pomodoro_screen_notification_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pomodoro_screen_notification_set_property;
	G_OBJECT_CLASS (klass)->constructor = pomodoro_screen_notification_constructor;
	G_OBJECT_CLASS (klass)->finalize = pomodoro_screen_notification_finalize;
	PomodoroScreenNotification_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/pomodoro/screen-notification.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "minutes_label", FALSE, PomodoroScreenNotification_private_offset + G_STRUCT_OFFSET (PomodoroScreenNotificationPrivate, minutes_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "seconds_label", FALSE, PomodoroScreenNotification_private_offset + G_STRUCT_OFFSET (PomodoroScreenNotificationPrivate, seconds_label));
}


static void pomodoro_screen_notification_gtk_buildable_interface_init (GtkBuildableIface * iface) {
	pomodoro_screen_notification_gtk_buildable_parent_iface = g_type_interface_peek_parent (iface);
	iface->parser_finished = (void (*) (GtkBuildable *, GtkBuilder*)) pomodoro_screen_notification_real_parser_finished;
}


static void pomodoro_screen_notification_instance_init (PomodoroScreenNotification * self) {
	self->priv = POMODORO_SCREEN_NOTIFICATION_GET_PRIVATE (self);
	self->priv->_close_on_activity = FALSE;
	self->priv->fade_in_timeout_id = (guint) 0;
	self->priv->fade_out_timeout_id = (guint) 0;
	self->priv->timer_elapsed_id = (gulong) 0;
	self->priv->close_on_activity_id = (guint) 0;
	self->priv->last_event_time = (guint32) 0;
	self->priv->last_motion_x = -1.0;
	self->priv->last_motion_y = -1.0;
	self->priv->_pass_through = TRUE;
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void pomodoro_screen_notification_finalize (GObject * obj) {
	PomodoroScreenNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
	pomodoro_screen_notification_unschedule_close_on_activity (self);
	_g_object_unref0 (self->priv->idle_monitor);
	_g_object_unref0 (self->priv->minutes_label);
	_g_object_unref0 (self->priv->seconds_label);
	G_OBJECT_CLASS (pomodoro_screen_notification_parent_class)->finalize (obj);
}


/**
     * A fullscreen notification.
     *
     * If idle_monitor is available, window blocks input events after user becomes idle for 600ms.
     * Otherwise, delay blocking until window is shown.
     *
     */
GType pomodoro_screen_notification_get_type (void) {
	static volatile gsize pomodoro_screen_notification_type_id__volatile = 0;
	if (g_once_init_enter (&pomodoro_screen_notification_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PomodoroScreenNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_screen_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroScreenNotification), 0, (GInstanceInitFunc) pomodoro_screen_notification_instance_init, NULL };
		static const GInterfaceInfo gtk_buildable_info = { (GInterfaceInitFunc) pomodoro_screen_notification_gtk_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType pomodoro_screen_notification_type_id;
		pomodoro_screen_notification_type_id = g_type_register_static (gtk_window_get_type (), "PomodoroScreenNotification", &g_define_type_info, 0);
		g_type_add_interface_static (pomodoro_screen_notification_type_id, GTK_TYPE_BUILDABLE, &gtk_buildable_info);
		g_once_init_leave (&pomodoro_screen_notification_type_id__volatile, pomodoro_screen_notification_type_id);
	}
	return pomodoro_screen_notification_type_id__volatile;
}


static void _vala_pomodoro_screen_notification_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	PomodoroScreenNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_pomodoro_screen_notification_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	PomodoroScreenNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, POMODORO_TYPE_SCREEN_NOTIFICATION, PomodoroScreenNotification);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



